searchNodes=[{"doc":"Constructs or deconstructs messages that conform to U-blox UBX binary protocol. NOTE: This documentation is incomplete. It will be finished as soon as possible.","ref":"UbxInterpreter.html","title":"UbxInterpreter","type":"module"},{"doc":"See UbxInterpreter.Utils.calculate_ubx_checksum/1 .","ref":"UbxInterpreter.html#calculate_ubx_checksum/1","title":"UbxInterpreter.calculate_ubx_checksum/1","type":"function"},{"doc":"Appends the latest data to any leftover data from the previous check_for_new_message operation. Arguments are the %UbxInterpreter{} struct and the newest data from the whichever source this struct is associated (must already by converted from binary to list). Returns {%UbxInterpreter{}, [list of payload bytes]} . If no valid UBX message was found, the payload list will be empty. This list is the raw payload contents. In order to convert to usable values, the deconstruct_message_to_map or deconstruct_message_to_list function must be called. NOTE: After a valid message has been received, the clear function must be called if you do not want the payload values to persist. Otherwise this function will continue to return a populated payload list even if a new valid message has not been received. Example: { ubx_interpreter , payload_list } = UbxInterpreter . check_for_new_message ( ubx_interpreter , new_data_list ) values_list = deconstruct_message_to_list ( byte_types_list , multipliers_list , payload_list ) ubx_interpreter = UbxInterpreter . clear ( ubx_interpreter )","ref":"UbxInterpreter.html#check_for_new_message/2","title":"UbxInterpreter.check_for_new_message/2","type":"function"},{"doc":"Similar to check_for_new_message , expect if a valid message is found, the process_fn function will be called. The arguments passed to process_fn include the message class, message ID, and the message payload, plus any additional_fn_args . This makes it easier to parse and process multiple messages contained within the same data stream. For example, you might have a GPS receiver that is outputing two different messages, and you want to send the contents of each message to a different GenServer. Example: ubx_interpreter = UbxInterpreter . check_for_new_messages_and_process ( ubx_interpreter , data_list , &amp; process_data_fn / 3 , [ ] )","ref":"UbxInterpreter.html#check_for_new_messages_and_process/4","title":"UbxInterpreter.check_for_new_messages_and_process/4","type":"function"},{"doc":"Empties the stored payload list","ref":"UbxInterpreter.html#clear/1","title":"UbxInterpreter.clear/1","type":"function"},{"doc":"See UbxInterpreter.Utils.construct_message_from_list/4 .","ref":"UbxInterpreter.html#construct_message_from_list/4","title":"UbxInterpreter.construct_message_from_list/4","type":"function"},{"doc":"See UbxInterpreter.Utils.construct_message_from_map/6 .","ref":"UbxInterpreter.html#construct_message_from_map/6","title":"UbxInterpreter.construct_message_from_map/6","type":"function"},{"doc":"See UbxInterpreter.Utils.construct_proto_message/3 .","ref":"UbxInterpreter.html#construct_proto_message/3","title":"UbxInterpreter.construct_proto_message/3","type":"function"},{"doc":"See UbxInterpreter.Utils.deconstruct_message_to_list/3 .","ref":"UbxInterpreter.html#deconstruct_message_to_list/3","title":"UbxInterpreter.deconstruct_message_to_list/3","type":"function"},{"doc":"Converts a list of payload bytes to a map containing usable values. The message contents are defined according to the byte_types and multipliers arguments. First the payload is split up into a list of values, separated according to their lenght in bytes.&lt;br&gt;Acceptable byte_types values and their corresponding primitive data type are as follows: 1 (uint8) 2 (uint16) 4 (uint32) 8 (uint64) -1 (int8) -2 (int16) -4 (int32) -8 (int64) 4.0 (float) 8.0 (double) NOTE: UBX messages do not typically contain float or double values represented in single-precision or double-precision form. Rather they use integer values with known multiplier to convert them to their decimal values. However, there is no reason we can't store them like this, so if you want to make a custom UBX message that uses float or double , go for it! Once each value has been converted from a list of bytes to an integer , float , or double , it is then multiplied by the corresponding number in the multipliers list. Finally it is stored in a map using the key specified by the keys list. Example: -coming soon-","ref":"UbxInterpreter.html#deconstruct_message_to_map/4","title":"UbxInterpreter.deconstruct_message_to_map/4","type":"function"},{"doc":"Create a new UbxInterpreter struct that can parse new data and store the most recently received output.","ref":"UbxInterpreter.html#new/0","title":"UbxInterpreter.new/0","type":"function"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html","title":"UbxInterpreter.ByteTypes","type":"module"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#double/0","title":"UbxInterpreter.ByteTypes.double/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#float/0","title":"UbxInterpreter.ByteTypes.float/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#int16/0","title":"UbxInterpreter.ByteTypes.int16/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#int32/0","title":"UbxInterpreter.ByteTypes.int32/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#int64/0","title":"UbxInterpreter.ByteTypes.int64/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#int8/0","title":"UbxInterpreter.ByteTypes.int8/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#uint16/0","title":"UbxInterpreter.ByteTypes.uint16/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#uint32/0","title":"UbxInterpreter.ByteTypes.uint32/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#uint64/0","title":"UbxInterpreter.ByteTypes.uint64/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.ByteTypes.html#uint8/0","title":"UbxInterpreter.ByteTypes.uint8/0","type":"macro"},{"doc":"","ref":"UbxInterpreter.Utils.html","title":"UbxInterpreter.Utils","type":"module"},{"doc":"","ref":"UbxInterpreter.Utils.html#calculate_ubx_checksum/1","title":"UbxInterpreter.Utils.calculate_ubx_checksum/1","type":"function"},{"doc":"","ref":"UbxInterpreter.Utils.html#construct_message_from_list/4","title":"UbxInterpreter.Utils.construct_message_from_list/4","type":"function"},{"doc":"","ref":"UbxInterpreter.Utils.html#construct_message_from_map/6","title":"UbxInterpreter.Utils.construct_message_from_map/6","type":"function"},{"doc":"","ref":"UbxInterpreter.Utils.html#construct_proto_message/3","title":"UbxInterpreter.Utils.construct_proto_message/3","type":"function"},{"doc":"","ref":"UbxInterpreter.Utils.html#deconstruct_message_to_list/3","title":"UbxInterpreter.Utils.deconstruct_message_to_list/3","type":"function"},{"doc":"","ref":"UbxInterpreter.Utils.html#deconstruct_message_to_map/4","title":"UbxInterpreter.Utils.deconstruct_message_to_map/4","type":"function"},{"doc":"UbxInterpreter TODO: Add description","ref":"readme.html","title":"UbxInterpreter","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding ubx_interpreter to your list of dependencies in mix.exs : def deps do [ { :ubx_interpreter , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/ubx_interpreter .","ref":"readme.html#installation","title":"UbxInterpreter - Installation","type":"extras"}]